Subject: Re: [core] CoAP accessed from standard RESTful client

From: Kujtim Hyseni <[email-masked]>
Date: Mon, 22 Oct 2012 09:11:16 +0000

Hi Carsten,

thank you for replying and introducing your forum.

I have few questions indeed regarding the CoAP:

1) Who is the language for describing CoAP web service functionalities? Since it is RESTful, regarding the Master's work at http://code.google.com/p/rest-api-code-gen/ I suppose is the WADL (Web Application Description Language), although there are presented other languages. Also, there states that WSDL 2.0 is also able to describe RESTful web services. But, I want also to know your opinion?

2) In my previous email (see it below) I have asked "How can be accessed the CoAP based embedded device from standard RESTful client?". Since it is still unclear I will comment further this question: I intend to access CoAP based device from Personal Computer. Also, I would like to have a "common" way of accessing CoAP device -  a way to consider it as a usual RESTful web service from the client's view point. Other alternative would be: Are there tools for generating CoAP RESTful clients given its description file? - server is my problem, and it usually provides data read from sensor.
I still don't know whether my question 2) is clear now? Yes when I say "standard RESTful client" I mean "existing HTTP client".

Best Wishes,
Kujtim Hyseni

> Subject: Re: CoAP accessed from standard RESTful client
> From: [email-masked]
> Date: Sat, 20 Oct 2012 13:12:15 +0200
> CC: [email-masked]
> To: [email-masked]
> 
> Hi Kujtim,
> 
> I think when you say "standard RESTful client" you mean "existing HTTP client".
> (Both CoAP and HTTP are based on the REST model, and both are, or are intended to be, standards.)
> 
> Indeed, the existing HTTP client could learn CoAP as a second protocol (I think that is your alternative 1) or it could make use of a proxy that translates the HTTP requests into CoAP requests, and the CoAP responses into HTTP responses.
> 
> What kind of existing HTTP client do you have in mind?
> 
>                                  oOo
> 
> 
> As a general observation, if you want to work in the CoRE/CoAP space, it is best to subscribe to the CoRE mailing list at:
> 
> 	https://www.ietf.org/mailman/listinfo/core
> 
> and ask questions there, so others can benefit from the answers as well.
> 
> Grüße, Carsten
> 
> 
> On Oct 20, 2012, at 12:05, Kujtim Hyseni <[email-masked]> wrote:
> 
> > Dear Mr./Mme.,
> > 
> > I have a question for You regarding the access of CoAP based embedded server from standard RESTful client.
> > 
> > How can be accessed the CoAP based embedded device from standard RESTful client?
> > 
> > I have two possibilities in my mind:
> > 1) The client is dedicated i.e. it is based on CoAP.
> > 2) There is a gateway/proxy which translates (compresses) original full RESTful requests to CoAP and vice versa - decompresses responses to standard RESTful protocol.
> > 
> > Waiting for response,
> > 
> > Best Wishes,
> > Kujtim Hyseni PhD student
>